/*
 * JBX_COPY.CMD  by mira308sw
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=19bb6041
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * the goal of this script is to have a way to copy mp3 file to jukebox without
 * need to use PC.
 * burn the script on a CD, and use it to copy music from a generic usb mass
 * storage device.
 * user will prompted each 50 MByte copied, so a great number of
 * file, can be copied in separate session.
 * user will prompted to choice if copy all albums, or confirm each album, and
 * if copy all songs inside album, or confirm each song.
 * folder structure level major of one are converted in one level simply changing
 * the folder separator character '/' with a minus '-'.
 * songs in usb root are copied in a fixed folder called /JBXCMD
 * it also possible to execute only a catalogue rebuild
 *
 * v 1.00: 19/12/2008   first release
 * v 1.01: 29/12/2008   changed temp file names, add CR in filelist,
 *                      correct Restore request, add reboot, no hello msg
 * v 2.00: 01/01/2009   no more backup, add rebuild catalogue, sorting routine
 * v 2.10: 17/01/2009   add suport for sw:7.10
 * v 3.00: 15/03/2009   change name to JBX_COPY, delete DirectPlay function,
 *                      use internal functions to build catalogue, no need reboot
 */

/* Functions and data types from Integrated C Interpreter
 */
typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef int                     BOOL;

typedef void                    DIR;
typedef void                    FILE;

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define NULL                    (void*)0
#define TRUE                    1
#define FALSE                   0

int     atoi                    ( char *s );
STATUS  close                   ( int hf );
STATUS  closedir                ( DIR *d );
STATUS  EiC_ExeFile             ( int argc,char **argv );
STATUS  fclose                  ( FILE *f );
STATUS  feof                    ( FILE *f );
char*   fgets                   ( char *s,int max,FILE *f );
FILE*   fopen                   ( char *fn,char *mode );
STATUS  fputs                   ( char *s,FILE *f );
void    free                    ( void *mem );
void    loadModule              ( int hf,int mode );
STATUS  logMsg                  ( char *fmt,...);
void*   malloc                  ( int size );
STATUS  mv                      ( char *src,char *dest );
int     open                    ( char *fn,int access,int mode );
DIR*    opendir                 ( char *dn );
int     putchar                 ( int c );
char*   strcat                  ( char *dest,char *s );
int     strcmp                  ( char *s1,char *s2 );
char*   strcpy                  ( char *dest,char *src );
int     strlen                  ( char *s );
int     strncmp                 ( char *s1,char *s2,int max );
char*   strrchr                 ( char *s,int c );
char*   strstr                  ( char *s1,char *s2 );
void    taskDelay               ( int tick );
DWORD   tickGet                 ( void );
STATUS  xcopy                   ( char *src,char *dest );
STATUS  xdelete                 ( char *src );

/* functions not yet known (for me)
 *
void    copy                    ( void );
void    creat                   ( void );
void    ExeScriptFile           ( void );
void    moduleFindByNameAndPath ( void );
void    rm                      ( void );
void    sqrt                    ( void );
void    symFindByNameAndType    ( void );
void    unldByModuleId          ( void );
void    unldByNameAndPath       ( void );
 */

/* Funcions and data type from modified builtins.out crc=19bb6041
 */

#define LOAD_NO_SYMBOLS         2
#define LOAD_LOCAL_SYMBOLS      4
#define LOAD_GLOBAL_SYMBOLS     8
#define LOAD_ALL_SYMBOLS        (LOAD_LOCAL_SYMBOLS|LOAD_GLOBAL_SYMBOLS)

void    AddGatewayHistory         ( void );
STATUS  AddUPGHistoryHeader       ( char *cd,char *target,char *action );
STATUS  BootRomFormatTffs         ( void );
void    CheckCRCDrive             ( void );
STATUS  CheckCRCFile              ( char *fn );
STATUS  ComputeCRCFile            ( char *fn,char *crc);
STATUS  EnableHistoryHandler      ( int on );
STATUS  EnableSetPowerOffHandler  ( int on );
int     Execute                   ( void *funptr );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters
void    Format                    ( void );
STATUS  GetBootromVersion         ( char *ver );
STATUS  GetCDVersion              ( char *ver );
STATUS  GetCurrentDateClock       ( char *dc );
STATUS  GetModuleId               ( int mid,char *tid );
STATUS  GetSearchResult           ( int ndx,char *res,char *path );
STATUS  GetSourceDrive            ( char *path );
STATUS  InstallHDDTestFiles       ( void );
int     IsFpInLoader              ( void );
int     IsPartitionCaseSensitive  ( void );
int     IsPartitionUnderRepair    ( void );
void    loadFile                  ( void );
STATUS  LockCDEject               ( int on );
STATUS  ReadFileCRC               ( char *fn,char *crc );
void    RebootSystem              ( void );
int     SearchAndTargetFileExclu  ( char *fn,char *tn,char *par[],int npar,char *root,char *dir );
STATUS  SetBootLoaderFlag         ( int stayInBootLoader );
STATUS  SetMasterFlashingOn       ( void );
STATUS  SetPartitionRepairState   ( int repair );
STATUS  SetPower                  ( int on );
STATUS  SetRedLedOn               ( int on );
STATUS  SetUPGInProgressInCDD     ( int on );
STATUS  SetUpgradeLogging         ( int on );
STATUS  StopCOMModule             ( int mid );
STATUS  StopHDDActivity           ( void );
STATUS  UpdateFSImage             ( void );
STATUS  UPGCopy                   ( char *src,char *dst,int cut );
STATUS  UPGDelete                 ( char *fn );
void*   UPGFindSymbol             ( char *sym );
STATUS  UPGLogMsg                 ( char *fmt,... );

/* Functions and data types from MMI module
 */
#define NO                            0
#define YES                           1

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationBargraph        ( void );
STATUS  StepBargraph                  ( char *txt, int per );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );

/* Functions and data types for RTx system
 */
// Drive letters
#define DRIVE_USB       "/bd0"
#define DRIVE_HDD       "/C"
#define DRIVE_CD        "/D"
#define DRIVE_TFFS      "/F"
#define DRIVE_NAV       "/H"
#define DRIVE_USER      "/I"
#define DRIVE_JBX       "/J"


/* extra C standard function, pull out through modified Builtins.out
 */

void *pf_fread;
void *pf_fwrite;
void *pf_fseek;
void *pf_sprintf;
void *pf_memset;
void *pf_memmove;
void *pf_strchr;
void *pf_stricmp;

void *pf_GetObjPtr;
void *pf_sendHddUpdateRequest;
char *g_C_MP3_BASIC;

/* these functions work only on modified Builtins.out crc=19bb6041
 */
#define EFO                         ExecuteFlasherOut
#define FREAD( ptr,size,n,fp )      EFO( pf_fread,ptr,size,n,fp )
#define FWRITE( ptr,size,n,fp )     EFO( pf_fwrite,ptr,size,n,fp )
#define FSEEK( fp,offset,from )     EFO( pf_fseek,fp,offset,from )
#define MEMSET( ptr,value,len )     EFO( pf_memset,ptr,value,len )
#define MEMMOVE( dst,src,len )      EFO( pf_memmove,dst,src,len )
#define STRCHR( str,chr )    (char*)EFO( pf_strchr,str,chr )
#define STRICMP( s1,s2 )            EFO( pf_stricmp,s1,s2 )
#define GETOBJPTR( id )      (void*)EFO( pf_GetObjPtr,id,0 )
#define SENDHDDUPDATEREQUEST()      EFO( pf_sendHddUpdateRequest,g_C_MP3_BASIC )

STATUS InitFunctionPtr ( void )
{
  int   l_iAnsw;

  pf_fread    =UPGFindSymbol( "fread" );
  pf_fwrite   =UPGFindSymbol( "fwrite" );
  pf_fseek    =UPGFindSymbol( "fseek" );
  pf_sprintf  =UPGFindSymbol( "sprintf" );
  pf_memset   =UPGFindSymbol( "memset" );
  pf_memmove  =UPGFindSymbol( "memmove" );
  pf_strchr   =UPGFindSymbol( "strchr" );
  pf_stricmp  =UPGFindSymbol( "LH_stricmp" );
  pf_GetObjPtr=UPGFindSymbol( "GetObjPtr__15C_OBJ_PTR_TableUsUs" );
  pf_sendHddUpdateRequest =UPGFindSymbol( "sendHddUpdateRequest__11C_MP3_BASIC" );

  if( pf_fread                !=NULL &&
      pf_fwrite               !=NULL &&
      pf_fseek                !=NULL &&
      pf_sprintf              !=NULL &&
      pf_memset               !=NULL &&
      pf_memmove              !=NULL &&
      pf_strchr               !=NULL &&
      pf_stricmp              !=NULL &&
      pf_GetObjPtr            !=NULL &&
      pf_sendHddUpdateRequest !=NULL )
  {
    g_C_MP3_BASIC =GETOBJPTR( 0x4DBC );
    if( g_C_MP3_BASIC!=NULL )
      return OK;
  }

  ShowNavigationQuestionScreen( "InitFunctionPtr() FAILED!", &l_iAnsw );
  return ERROR;
}

/* Other builtins Functions and data type
 */
int     UPGSearchFile       ( char *fn, char *root, char *param, char *tabledir );
STATUS  UPGGetSearchResult  ( int ndx,char *res );
STATUS  UPGMKDir            ( char *dir);
STATUS  UPGMKDelete         ( char *dir);
STATUS  GetFileSize         ( char *fn, int *size);


/* Functions and data types for .INF file managment
 */
void    PatchCRC ( char *p_crc )
{
  if( p_crc[0]==' ' )   p_crc[0]='0';
  if( p_crc[1]==' ' )   p_crc[1]='0';
  if( p_crc[2]==' ' )   p_crc[2]='0';
  if( p_crc[3]==' ' )   p_crc[3]='0';
}

STATUS  UpdateFileInf ( char *p_sFile )
{
  FILE *l_f;
  char  l_crc[9];
  char  l_sInf[256];

  l_crc[0]=l_crc[1]=l_crc[2]=l_crc[3]=0;
  ComputeCRCFile( p_sFile,l_crc+4 );
  PatchCRC( l_crc+4 );
  l_crc[8]='\n';
  strcpy( l_sInf,p_sFile );
  strcat( l_sInf,".inf" );
  l_f=fopen( l_sInf,"r+b" );
  if( l_f==NULL )
  {
    l_f=fopen( l_sInf,"wb" );
    if( l_f==NULL )
      return ERROR;
  }
  FWRITE( l_crc,9,1,l_f );
  fclose( l_f );
  ComputeCRCFile( l_sInf,l_crc );
  PatchCRC( l_crc );
  l_f=fopen( l_sInf,"r+b" );
  if( l_f==NULL )
    return ERROR;
  FWRITE( l_crc,4,1,l_f );
  fclose( l_f );
  return OK;
}

int   FileExist ( char *p_sFile )
{
  FILE *l_f=fopen( p_sFile,"rb" );
  if( l_f==NULL )
    return FALSE;
  fclose( l_f );
  return TRUE;
}

typedef struct
{
  char  data[0x1F0];
} MP3_PLAY_INFO;

/****************************** JBX.CMD ******************************/

typedef struct
{
  int   m_unit;
  int   m_mega;
} t_longint;

#define _1MBYTE                 (1048576)
#define BREAK                   (2)
#define MAX_SIZE                (50*_1MBYTE)
#define USB_NOTCOPIED_FILE      "/JBX_NOTCOPIED.TXT"
#define USB_LASTCOPIED_FILE     "/JBX_LASTCOPIED.TXT"
#define USB_LIST_FILE           "/JBX_FILELIST.TXT"
#define COL_SEP                 '\t'

#define JBX_DEF_FOLDER          "/JBXCMD"


int  IsMP3 ( char *p_sFile )
{
  int   l_l=strlen( p_sFile );
  char *l_p=p_sFile+l_l-4;
  if( l_p<=p_sFile || l_l>256-4 )
    return FALSE;
  return  l_p[0]=='.' &&
        ( l_p[1]=='m' || l_p[1]=='M' ) &&
        ( l_p[2]=='p' || l_p[2]=='P' ) &&
          l_p[3]=='3';
}

void AdjustJbxPath ( char *p_sFile )
{
  char  l_sSng[256];
  char *l_p   =STRCHR( p_sFile+1,'/' );
  char *l_pSng=strrchr( p_sFile,'/' );

  if( l_p==l_pSng )
  {
    strcpy( l_sSng,l_pSng );
    strcpy( l_pSng,JBX_DEF_FOLDER );
    strcat( l_pSng,l_sSng );
  }
  else
  {
    for( l_p=STRCHR( l_p+1,'/' ) ; l_p<l_pSng ; l_p=STRCHR( l_p,'/' ) )
      *l_p='-';
  }
}

void AddFileSize ( t_longint *p_liSize,int p_iAdd )
{
  p_liSize->m_unit += p_iAdd;
  if( p_liSize->m_unit > _1MBYTE )
  {
    p_liSize->m_mega += p_liSize->m_unit/_1MBYTE;
    p_liSize->m_unit %= _1MBYTE;
  }
}

int  CreateList ( char* p_sJob,t_longint *p_liSize )
{
  char  l_sFile[256];
  char  l_sText[256];
  char  l_sAlb[256];
  char  l_s[256];
  int   l_nFile;
  int   l_iSize;
  int   l_i;
  int   l_iLenDrv;
  int   l_iSkipped=0;
  int   l_iCopyAlb=TRUE;
  int   l_iAllAlb=TRUE;
  int   l_iAllSongs=TRUE;
  int   l_iCopy;
  FILE* l_pList;

  l_pList=fopen( DRIVE_USB USB_LIST_FILE,"wb" );
  if( l_pList==NULL )
    return ERROR;

  strcpy( l_sText,"Scan for MP3" );
  ShowNavigationBargraph();
  StepBargraph( l_sText,0 );

  l_iLenDrv=strlen( p_sJob );
  p_liSize->m_unit=0;
  p_liSize->m_mega=0;
  l_nFile=UPGSearchFile( "*.MP3",p_sJob,NULL,NULL );

  ShowNavigationQuestionScreen( "Copy all Albums ?",&l_iAllAlb );

  for( l_i=0 ; l_i<l_nFile ; l_i++ )
  {
    if( UPGGetSearchResult( l_i,l_sFile )==ERROR )
      l_iSkipped++;
    else if( IsMP3( l_sFile )==FALSE )
      l_iSkipped++;
    else
    {
      strcpy( l_s,l_sFile+l_iLenDrv );
      *strrchr( l_s,'/' )=0;
      if( *l_s==0 )
        strcpy( l_s,"/" );
      if( strcmp( l_sAlb,l_s )==0 )
      {
        if( l_iCopyAlb==NO )
        {
          l_iSkipped++;
          continue;
        }
      }
      else if( l_iAllAlb==NO )
      {
        strcpy( l_sAlb,l_s );
        EFO( pf_sprintf,l_sText,"Album %s ?",l_sAlb );
        ShowNavigationQuestionScreen( l_sText,&l_iCopyAlb );
        if( l_iCopyAlb==NO )
        {
          l_iSkipped++;
          continue;
        }
        EFO( pf_sprintf,l_sText,"All songs of %s ?",l_sAlb );
        ShowNavigationQuestionScreen( l_sText,&l_iAllSongs );
      }
      if( l_iAllSongs==NO )
      {
        EFO( pf_sprintf,l_sText,"Song %s ?",strrchr( l_sFile,'/' ) );
        ShowNavigationQuestionScreen( l_sText,&l_iCopy );
        if( l_iCopy==NO )
        {
          l_iSkipped++;
          continue;
        }
      }
      ShowNavigationBargraph();
      StepBargraph( strrchr( l_sFile,'/' ),100*l_i/l_nFile );

      fputs( l_sFile+l_iLenDrv,l_pList );
      if( GetFileSize( l_sFile,&l_iSize )!=ERROR )
      {
        EFO( pf_sprintf,l_sFile,"%c%d",COL_SEP,l_iSize );
        fputs( l_sFile,l_pList );
        AddFileSize( p_liSize,l_iSize );
      }
      fputs( "\r\n",l_pList );
    }
  }
  fclose( l_pList );
  l_nFile-=l_iSkipped;

  if( l_nFile<=0 )
  {
    ShowNavigationBargraph();
    StepBargraph( "No files MP3!",100 );
    UPGDelete( DRIVE_USB USB_LIST_FILE );
    taskDelay( 3000 );
  }
  return l_nFile;
}

int  ReadLastCopied ( char *p_sPath )
{
  char  l_s[16];
  char *l_sLast;
  FILE *l_pLast;
  char  l_sPath[256];

  strcpy( l_sPath,p_sPath );
  strcat( l_sPath,USB_LASTCOPIED_FILE );
  l_pLast=fopen( l_sPath,"r" );
  if( l_pLast==NULL )
    return 0;
  l_sLast=fgets( l_s,sizeof( l_s ),l_pLast );
  fclose( l_pLast );
  if( l_sLast==NULL )
    return 0;
  return atoi( l_sLast );
}

int  WriteLastCopied ( char *p_sPath,int p_iLast )
{
  char  l_s[16];
  FILE *l_pLast;
  char  l_sPath[256];

  strcpy( l_sPath,p_sPath );
  strcat( l_sPath,USB_LASTCOPIED_FILE );
  l_pLast=fopen( l_sPath,"w" );
  if( l_pLast==NULL )
    return ERROR;
  EFO( pf_sprintf,l_s,"%d",p_iLast );
  fputs( l_s,l_pLast );
  fputs( "\n",l_pLast );
  fclose( l_pLast );
  return OK;
}

int  WriteNotCopied ( char *p_sPath,char *p_sFile )
{
  FILE *l_pNoCpy;
  char  l_sPath[256];

  strcpy( l_sPath,p_sPath );
  strcat( l_sPath,USB_NOTCOPIED_FILE );

  if( p_sFile )
    l_pNoCpy=fopen( l_sPath,"a" );
  else
    l_pNoCpy=fopen( l_sPath,"w" );

  if( l_pNoCpy==NULL )
    return ERROR;

  if( p_sFile )
  {
    fputs( p_sFile,l_pNoCpy );
    fputs( "\r\n",l_pNoCpy );
  }
  fclose( l_pNoCpy );
  return OK;
}

int  CopyFile ( FILE* p_pList,int p_i,int p_pLast,char *p_sJob )
{
  char l_sSrc[256];
  char l_sDst[256];
  char l_sFile[256];
  char *l_p;
  int  l_iSize;

  for( ; p_pLast<p_i ; p_pLast++ )
    if( fgets( l_sFile,sizeof( l_sFile ),p_pList )==NULL )
      return ERROR;
  for( l_p=l_sFile ; *l_p && *l_p!=COL_SEP && *l_p!='\n' && *l_p!='\r' ; l_p++ );
  *l_p=0;
  strcpy( l_sSrc,p_sJob );
  strcat( l_sSrc,l_sFile );
  strcpy( l_sDst,DRIVE_JBX );
  strcat( l_sDst,l_sFile );
  AdjustJbxPath( l_sDst );
  if( GetFileSize( l_sSrc,&l_iSize )==ERROR )
  {
    WriteNotCopied( p_sJob,l_sFile );
    return OK;
  }
  if( UPGCopy( l_sSrc,l_sDst,FALSE )==ERROR )
  {
    WriteNotCopied( p_sJob,l_sFile );
    return ERROR;
  }
  return l_iSize;
}

int  CopyList ( FILE* p_pList,int p_iTotal,char *p_sJob )
{
  char  l_sDescr[256];
  char  l_s[256];
  int   l_i;
  int   l_iSize;
  int   l_iPerc;
  int   l_iList=0;
  int   l_iLast=ReadLastCopied( p_sJob );

  strcpy( l_sDescr,"Copy files" );
  do
  {
    l_iPerc=0;
    l_iSize=0;
    ShowNavigationBargraph();
    do
    {
      if( l_iSize>=l_iPerc )
      {
        StepBargraph( l_sDescr,l_iSize/(MAX_SIZE/100) );
        l_iPerc=l_iSize+(MAX_SIZE/10);
      }
      l_i=CopyFile( p_pList,++l_iLast,l_iList,p_sJob );
      if( l_i==ERROR )
        return ERROR;
      l_iSize+=l_i;
      l_iList=l_iLast;
    }
    while( l_iSize<MAX_SIZE && l_iLast<p_iTotal );

    if( l_iLast>=p_iTotal )
      l_i=-1;
    else
    {
      EFO( pf_sprintf,l_s,"%d%% done. Continue ?",100*l_iLast/p_iTotal );
      ShowNavigationQuestionScreen( l_s,&l_i );
    }
  }
  while( l_i==YES );

  WriteLastCopied( p_sJob,l_iLast );
  return ( l_i<0 ? OK : BREAK );
}

int ExecuteJob ( char *p_sJob )
{
  char  l_sList[256];
  char  l_s[256];
  int   l_iAnsw;
  int   l_iLast;
  int   l_iCreate;
  int   l_nFile;
  FILE* l_pList;
  t_longint l_liTotSize;
  char *l_p;

  strcpy( l_sList,p_sJob );
  strcat( l_sList,USB_LIST_FILE );
  l_pList=fopen( l_sList,"r" );
  if( l_pList==NULL )
    l_iCreate=TRUE;
  else
  {
    l_liTotSize.m_unit=0;
    l_liTotSize.m_mega=0;
    l_iLast=ReadLastCopied( p_sJob );

    for( l_nFile=0 ; fgets( l_s,sizeof( l_s ),l_pList )!=NULL ; l_nFile++ )
    {
      if( l_nFile>=l_iLast )
        AddFileSize( &l_liTotSize,atoi( STRCHR( l_s,COL_SEP )+1 ) );
    }
    fclose( l_pList );

    if( !l_nFile )
      l_iCreate=TRUE;
    else
    {
      l_iCreate=FALSE;
      EFO( pf_sprintf,l_s,"%d%% already copied. Continue ?",100*l_iLast/l_nFile );
      ShowNavigationQuestionScreen( l_s,&l_iAnsw );
      if( l_iAnsw==NO )
        return BREAK;
    }
  }
  if( l_iCreate==TRUE )
  {
    l_iLast=0;

    if( WriteLastCopied( p_sJob,l_iLast )==ERROR ||
        WriteNotCopied( p_sJob,NULL )==ERROR )
      return ERROR;

    l_nFile=CreateList( p_sJob,&l_liTotSize );
    if( l_nFile<=0 )
    {

      return ERROR;
    }
  }
  EFO( pf_sprintf,l_s,"%d files, ",l_nFile-l_iLast );
  l_p=l_s+strlen( l_s );
  if( l_liTotSize.m_mega>1024 )
    EFO( pf_sprintf,l_p,"%dGByte",(l_liTotSize.m_mega+1023)/1024 );
  else if( l_liTotSize.m_mega )
    EFO( pf_sprintf,l_p,"%dMByte",l_liTotSize.m_mega );
  else if( l_liTotSize.m_unit>1024 )
    EFO( pf_sprintf,l_p,"%dKByte",(l_liTotSize.m_unit+1023)/1024 );
  else
    EFO( pf_sprintf,l_p,"%dByte",l_liTotSize.m_unit );
  strcat( l_p," required. Continue ?" );
  ShowNavigationQuestionScreen( l_s,&l_iAnsw );
  if( l_iAnsw==NO )
    return BREAK;

  l_pList=fopen( l_sList,"r" );
  if( l_pList==NULL )
    return ERROR;
  l_iAnsw=CopyList( l_pList,l_nFile,p_sJob );
  fclose( l_pList );

  return l_iAnsw;
}

int  isCopyInProgress ( void )
{
  FILE *l_pList=fopen( DRIVE_USB USB_LIST_FILE,"r" );
  if( l_pList==NULL )
    return FALSE;
  fclose( l_pList );
  return TRUE;
}

int  jbx_copy ( void )
{
  int   l_i;
  int   l_iAnsw;

  if( isCopyInProgress() )
  {
    l_i=ExecuteJob( DRIVE_USB );
    if( l_i!=OK )
      return l_i;
  }
  else
  {
    ShowNavigationQuestionScreen( "Only Rebuild Catalogue.dat?", &l_iAnsw );
    if( l_iAnsw==NO )
    {
      l_i=ExecuteJob( DRIVE_USB );
      if( l_i!=OK )
        return l_i;
    }
  }

  l_i=SENDHDDUPDATEREQUEST();

  UPGDelete( DRIVE_USB USB_LIST_FILE );
  UPGDelete( DRIVE_USB USB_LASTCOPIED_FILE );
  return l_i;
}

int  main ( int argc, char **argv )
{
  int  l_iAnsw = FALSE;

  if( InitFunctionPtr()==OK )
  {
    switch( jbx_copy() )
    {
    case ERROR:
      ShowNavigationQuestionScreen( "Copy failed!", &l_iAnsw );
      break;
    case OK:
      ShowNavigationQuestionScreen( "Copy completed. Reboot ?",&l_iAnsw );
      if( l_iAnsw==YES )
        RebootSystem();
      break;
    case BREAK:
      ShowNavigationQuestionScreen( "Copy halted by user!",&l_iAnsw );
      break;
    }
  }
  ClearScreen();
  return OK;
}

