/*
 * USB_DIRPLAY.CMD  by mira308sw
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=7d4ba5c9
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * Enable play MP3 directly from USB port on 7.xx RT4 device
 *
 * v 01.00: 15/03/2008   first release
 * v 02.00: 19/03/2008   activate usb till reboot
 */

/* Functions and data types from Integrated C Interpreter
 */
typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;
typedef void (*FPTR)(void);

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define NULL                    (void*)0
#define NO                      0
#define YES                     1


int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters
void*   UPGFindSymbol             ( char *sym );

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );



/* extra C standard functions, pull out through modified Builtins.out
 */

FPTR  pf_malloc;

/* RT4 system functions, pull out through modified Builtins.out
 */

FPTR  pf_GetObjPtr;
FPTR  pf_USBChangeState;
FPTR  pf_RegisterUsbEvt;
BYTE *pf_Execute;

BYTE *g_C_MEDIA_MANAGER;

/* these functions work only on modified Builtins.out crc=7d4ba5c9
 */
#define EFO                         ExecuteFlasherOut
#define MALLOC( size )       (void*)EFO( pf_malloc,size )
#define GETOBJPTR( id )      (void*)EFO( pf_GetObjPtr,id,0 )
#define REGISTERUSBEVT( fun,data )  EFO( pf_RegisterUsbEvt,fun,data )

STATUS InitFunctionPtr ( void )
{
  int   l_iAnsw;

  pf_malloc               =UPGFindSymbol( "malloc" );
  pf_GetObjPtr            =UPGFindSymbol( "GetObjPtr__15C_OBJ_PTR_TableUsUs" );
  pf_USBChangeState       =UPGFindSymbol( "USBChangeState__15C_MEDIA_MANAGERPvQ215C_MEDIA_MANAGER15TYPE_MM_COMMAND" );
  pf_RegisterUsbEvt       =UPGFindSymbol( "usbBulkDynamicAttachRegister" );
  pf_Execute              =UPGFindSymbol( "s_Execute__10C_BUILTINS" );

  if( pf_malloc           !=NULL &&
      pf_GetObjPtr        !=NULL &&
      pf_USBChangeState   !=NULL &&
      pf_RegisterUsbEvt   !=NULL &&
      pf_Execute          !=NULL )
  {
    g_C_MEDIA_MANAGER =GETOBJPTR( 0x5140 );
    if( g_C_MEDIA_MANAGER!=NULL )
      return OK;
  }

  ShowNavigationQuestionScreen( "InitFunctionPtr() FAILED!", &l_iAnsw );
  return ERROR;
}

typedef struct
{
  DWORD m_funptr;
  DWORD m_data;
} t_executeparam;


int  main ( int argc, char **argv )
{
  t_executeparam  *l_ep;
  int   l_iAnsw;

  if( InitFunctionPtr()!=OK )
    return OK;

  l_ep=MALLOC( sizeof( *l_ep ) );
  if( l_ep==NULL )
    ShowNavigationQuestionScreen( "malloc ERROR", &l_iAnsw );
  else
  {
    l_ep->m_funptr=(DWORD)pf_USBChangeState;
    l_ep->m_data  =(DWORD)g_C_MEDIA_MANAGER;
    REGISTERUSBEVT( pf_Execute+0x58,l_ep );
    ShowNavigationQuestionScreen( "Activated. DO NOT reboot!", &l_iAnsw );
  }
  return OK;
}

